/* from Henry Spencer's stringlib */
/* modified by sb 6/27/94 for case-insensitive comparison */

#include <string.h>
#include <ctype.h>
#include "extras.h"

/*
 * stristr - find first occurrence of wanted in s, ignoring case
 */

char *				/* found string, or NULL if none */
stristr(s, wanted)
const char *s;
const char *wanted;
{
	register const char *scan;
	register size_t len;
	register char firstc;

	/*
	 * The odd placement of the two tests is so "" is findable.
	 * Also, we inline the first char for speed.
	 * The ++ on scan has been moved down for optimization.
	 */
	firstc = *wanted;
	len = strlen(wanted);
	for (scan = s;
	     toupper(*scan) != toupper(firstc) ||
	     strnicmp(scan, wanted, len) != 0; ) {
		if (*scan++ == '\0')
			return(NULL);
	}
	return((char *)scan);
}
